ProcedureDLL.b MEM_DataInit(*aData.MEM_DataStructure, aSize.l)
  Protected vReturn.b
  Protected vCurSize.l
  Protected vTmp.l
  
  aSize = (Int(aSize/64000)+1)*64000
  
  If *aData\pData = 0
    vCurSize = 0
    *aData\pData = AllocateMemory(aSize)
  Else
    vCurSize = *aData\lCurSize
    vTmp = ReAllocateMemory(*aData\pData, aSize)
    If vTmp <> 0 ; *aData\pData
      *aData\pData = vTmp
    EndIf  
  EndIf
    
  If *aData\pData = 0
    vReturn = #False
  Else  
    *aData\lMaxSize = aSize
    *aData\lCurSize = vCurSize
    vReturn = #True
  EndIf  
  
  ProcedureReturn vReturn
EndProcedure

ProcedureDLL.b MEM_DataAdd( *aDest.MEM_DataStructure, *aSource.MEM_DataStructure)
  Protected vSourceSize.l
  Protected vDestSize.l
  Protected vDestMaxSize.l
  
  vSourceSize.l    = *aSource\lCursize  
  vDestSize.l      = *aDest\lCurSize
  vDestMaxSize.l   = *aDest\lMaxsize  
    
  If (vDestMaxSize < (vSourceSize + vDestSize))
    If (MEM_DataInit(*aDest, vSourceSize + vDestSize)) = #False
      ProcedureReturn #False      
    EndIf
    *aDest\lCursize = vDestSize
  EndIf
  
  CopyMemory(*aSource\pData, *aDest\pData + vDestSize , vSourceSize)       
  *aDest\lCursize = vSourceSize + vDestSize   
  ProcedureReturn #True
EndProcedure

ProcedureDLL.b MEM_DataAddString(*aData.MEM_DataStructure, aString.s)  
  Protected vLen.l
  Protected vTmp.MEM_DataStructure
  Protected vReturn.b
   
  vLen = Len(aString)
  vTmp\pData = @aString
  vTmp\lCurSize  = vLen
  vTmp\lMaxSize  = vLen
  vReturn = MEM_DataAdd(*aData, vTmp)
  ProcedureReturn vReturn
EndProcedure

ProcedureDLL.b MEM_DataReplace(*aData.MEM_DataStructure, aSource.s, aDest.s)
  Protected vSourceLen.l
  Protected vDestLen.l
  Protected vCurSize.l
  Protected vMaxSize.l
  Protected vCount.w
  Protected vFind.w
  Protected *tmp.l
  Protected vReturn.b
  
  vSourceLen   = Len(aSource)
  vDestLen     = Len(aDest)
  vCurSize     = *aData\lCursize  
  vMaxSize     = *aData\lMaxsize  
  vFind        = 0

  If (vDestLen > vSourceLen)
    For i = vCurSize To 0 Step -1
      vCount= 0
      For j = 1 To vSourceLen
        If PeekB(*aData\pData + i - vSourceLen + j - 1) = Asc(Mid(aSource,j,1))
          vCount = vCount + 1
        EndIf
      Next 
      If vCount = vSourceLen   
         vFind = vFind + 1   
      EndIf
    Next
    If (vFind > 0)
      MEM_DataInit(*aData, vMaxSize + (vFind*(vDestLen - vSourceLen)))
    EndIf  
  EndIf
  *tmp = AllocateMemory((vDestLen * vCurSize)/vSourceLen)
  If *tmp
    For i = vCurSize To 0 Step -1
      vCount= 0
      For j = 1 To vSourceLen
        If PeekB(*aData\pData + i - vSourceLen + j - 1) = Asc(Mid(aSource,j,1))
          vCount = vCount + 1
        EndIf
      Next 
      If vCount = vSourceLen   
        CopyMemory(*aData\pData + i, *tmp, *aData\lCurSize - i)     
        CopyMemory(@aDest, *aData\pData + i - vSourceLen , vDestLen)          
        CopyMemory(*tmp, *aData\pData + i - vSourceLen + vDestLen, *aData\lCurSize - i) 
        *aData\lCurSize = *aData\lCurSize + (vDestLen-vSourceLen)
      EndIf    
    Next
    FreeMemory(*tmp)
    vReturn = #True
  Else
    vReturn = #False
  EndIf
  ProcedureReturn vReturn
EndProcedure

; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 14
; Folding = -